/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

/* sisstring.h - a string library */

#ifndef __SISSTRING_H__
#define __SISSTRING_H__

struct sstring;

struct sstring *ss_init(int size);

struct sstring *ss_init_alias(void);

int ss_destroy(struct sstring *s);

int ss_copy(struct sstring *dest, struct sstring *src);

int ss_cmp(struct sstring *s1, struct sstring *s2, int *result);

int ss_len(struct sstring *s, int *len);

int ss_allocated(struct sstring *s, int *array_size);

int ss_alias(struct sstring *dest, struct sstring *src, int start, int end);

int cstring2ss_alias(struct sstring *dest, char *src, int len);

int cstring2ss(struct sstring *dest, char *src, int len);

int ss2cstring(char *dest, int len, struct sstring *src);

int ss_sprintf(struct sstring *dest, char *fmt, ...);

int ss_cat(struct sstring *dest, struct sstring *src);

#endif /* __SISSTRING_H__ */
